//----------------------------------------------------------------------------------------------------------------------
// cloptions	PROCESS COMMAND LINE			created on 	27 Jun 2013						Copyright Geoff Kaniuk 2013
//----------------------------------------------------------------------------------------------------------------------
//  This file is part of Tio.
//
//  Tio is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  Tio is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with Tio.  If not, see <http://www.gnu.org/licenses/>.
//----------------------------------------------------------------------------------------------------------------------
// A copy of the GNU General Public License is released with this software in the file COPYING
//----------------------------------------------------------------------------------------------------------------------

#include <stdio.h>		// libc
#include <stdlib.h>
#include <getopt.h>
#include <string.h>

#include <cstddef>
#include <vector>		// std

#ifndef CLOPTIONS_H_
#define CLOPTIONS_H_

//----------------------------------------------------------------------------------------------------------------------
// CLASS Commandline
//
namespace Tio
{
	using std::vector;

	class Commandline
	{
		private:
			const char* noshortoptions;  									// Must not be null

			struct option* options;											// The list of option for getopt_long

			int nopt;														// Specified number of options

			vector<char*>params;											// Non-option items on cl

		public:
			Commandline(const int pnopt, const char** opnames);
			~Commandline();

			int get_option(int argc, char *const *argv);					// Return option number

			const char* get_parameter(const size_t par);					// The parameter cstring

			const vector<char*>& get_parameters(void){ return params; }		// All parameters
	};
}
#endif 
// END cloptions
//----------------------------------------------------------------------------------------------------------------------
